## @file
# Define Global Variables

package GVariables;

##################################################
## the object constructor (simplistic version)  ##
##################################################
sub new {
    my $self  = {};    
    $self->{SRC_Name}             = "[SourceName]";
    $self->{SRC_OBSID}            = "[ObsID]";
    $self->{SRC_EXP}              = "[Exposure]";
    $self->{SRC_RA}               = undef;
    $self->{SRC_DEC}              = undef; 
    $self->{SRC_NH}               = undef;
    $self->{PN}					  = undef;
    $self->{MOS}				  = undef;
    $self->{RGS}				  = undef;
    $self->{OM}					  = undef;
    $self->{ANA_epatplot}	      = undef;
    $self->{GTI_optimize_SN_flag} = undef;
    $self->{GTI_mos1energy_cut}   = undef;
    $self->{GTI_mos2energy_cut}   = undef;
    $self->{GTI_pnenergy_cut}     = undef;
    $self->{GTI_MOS1_Rate}        = undef;
    $self->{GTI_MOS2_Rate}        = undef;
    $self->{GTI_PN_Rate}          = undef;
    $self->{GTI_timebin}          = undef;
    $self->{EDC_pn_ene_low}       = [];
    $self->{EDC_pn_ene_high}      = [];
    $self->{EDC_m1_ene_low}       = [];
    $self->{EDC_m1_ene_high}      = [];
    $self->{EDC_m2_ene_low}       = [];
    $self->{EDC_m2_ene_high}      = [];
    $self->{EDC_pn_likelihood_detection}  = undef;
    $self->{EDC_mos_likelihood_detection} = undef;
    $self->{EDC_sourcematch} = undef;
    $self->{EDC_cameramatch} = undef;
    $self->{OM_sourcematch}  = undef;
    $self->{PG_timebinning}  = undef;
    $self->{PG_timestart}    = undef;
    $self->{PG_timeend}      = undef;
    $self->{PG_minpi}        = undef;
    $self->{PG_maxpi}        = undef;
    $self->{PG_aringcx}      = undef;
    $self->{PG_aringcy}      = undef;
    $self->{PG_innerrad}     = undef;
    $self->{PG_outerrad}     = undef;
    $self->{PG_sx}           = undef;
    $self->{PG_sy}           = undef;
    $self->{PG_source_rad}   = undef;
    $self->{PG_areafactor}   = undef;
    $self->{LC_pn_timebin}   = undef;
    $self->{LC_m1_timebin}   = undef;
    $self->{LC_m2_timebin}   = undef; 
    $self->{LC_lc_pn_enertot_low} = undef;
    $self->{LC_lc_pn_enertot_up}  = undef;
    $self->{LC_lc_pn_ener1_low}   = undef;
    $self->{LC_lc_pn_ener1_up}    = undef;
    $self->{LC_lc_pn_ener2_low}   = undef;
    $self->{LC_lc_pn_ener2_up}    = undef;
    $self->{LC_lc_pn_ener3_low}   = undef;
    $self->{LC_lc_pn_ener3_up}    = undef;
    $self->{LC_lc_m1_enertot_low} = undef;
    $self->{LC_lc_m1_enertot_up}  = undef;
    $self->{LC_lc_m1_ener1_low}   = undef;
    $self->{LC_lc_m1_ener1_up}    = undef;
    $self->{LC_lc_m1_ener2_low}   = undef;
    $self->{LC_lc_m1_ener2_up}    = undef;
    $self->{LC_lc_m1_ener3_low}   = undef;
    $self->{LC_lc_m1_ener3_up}    = undef;
    $self->{LC_lc_m2_enertot_low} = undef;
    $self->{LC_lc_m2_enertot_up}  = undef;
    $self->{LC_lc_m2_ener1_low}   = undef;
    $self->{LC_lc_m2_ener1_up}    = undef;
    $self->{LC_lc_m2_ener2_low}   = undef;
    $self->{LC_lc_m2_ener2_up}    = undef;
    $self->{LC_lc_m2_ener3_low}   = undef;
    $self->{LC_lc_m2_ener3_up}    = undef;
    $self->{LC_lc_pn_highrad_low} = undef;
    $self->{LC_lc_pn_highrad_up}  = undef;
    $self->{LC_lc_m1_highrad_low} = undef;
    $self->{LC_lc_m1_highrad_up}  = undef;
    $self->{LC_lc_m2_highrad_low} = undef;
    $self->{LC_lc_m2_highrad_up}  = undef;
    $self->{LC_lc_pn_e1_low}      = undef;
    $self->{LC_lc_pn_e1_up}       = undef;
    $self->{LC_lc_pn_e2_low}      = undef;
    $self->{LC_lc_pn_e2_up}       = undef;
    $self->{LC_lc_m1_e1_low}      = undef;
    $self->{LC_lc_m1_e1_up}       = undef;
    $self->{LC_lc_m1_e2_low}      = undef;
    $self->{LC_lc_m1_e2_up}       = undef;
    $self->{LC_lc_m2_e1_low}      = undef;
    $self->{LC_lc_m2_e1_up}       = undef; 
    $self->{LC_lc_m2_e2_low}      = undef;
    $self->{LC_lc_m2_e2_up}       = undef;
    $self->{LC_pn_srcregion}         = undef;
    $self->{LC_pn_bkgregion}         = undef;
    $self->{LC_pn_srcregion_X}       = undef;
    $self->{LC_pn_srcregion_Y}       = undef;
    $self->{LC_pn_srcregion_R1}      = undef;
    $self->{LC_pn_srcregion_R2}      = undef;
    $self->{LC_pn_srcregion_XLength} = undef;
    $self->{LC_pn_srcregion_YLength} = undef;
    $self->{LC_pn_bkgregion_X}       = undef;
    $self->{LC_pn_bkgregion_Y}       = undef;
    $self->{LC_pn_bkgregion_R1}      = undef;
    $self->{LC_pn_bkgregion_R2}      = undef;
    $self->{LC_pn_bkgregion_XLength} = undef;
    $self->{LC_pn_bkgregion_YLength} = undef;
    $self->{LC_pn_areafactor}        = undef;
    $self->{LC_pn_rad_start_bkgregion} = undef;
    $self->{LC_m1_srcregion}         = undef;
    $self->{LC_m1_bkgregion}         = undef;
    $self->{LC_m1_srcregion_X}       = undef;
    $self->{LC_m1_srcregion_Y}       = undef;
    $self->{LC_m1_srcregion_R1}      = undef;
    $self->{LC_m1_srcregion_R2}      = undef;
    $self->{LC_m1_srcregion_XLength} = undef;
    $self->{LC_m1_srcregion_YLength} = undef;
    $self->{LC_m1_bkgregion_X}       = undef;
    $self->{LC_m1_bkgregion_Y}       = undef;
    $self->{LC_m1_bkgregion_R1}      = undef;
    $self->{LC_m1_bkgregion_R2}      = undef;
    $self->{LC_m1_bkgregion_XLength} = undef;
    $self->{LC_m1_bkgregion_YLength} = undef;
    $self->{LC_m1_areafactor}        = undef;
    $self->{LC_m1_rad_start_bkgregion} = undef;
    $self->{LC_m2_srcregion}         = undef;
    $self->{LC_m2_bkgregion}         = undef;
    $self->{LC_m2_srcregion_X}       = undef;
    $self->{LC_m2_srcregion_Y}       = undef;
    $self->{LC_m2_srcregion_R1}      = undef;
    $self->{LC_m2_srcregion_R2}      = undef;
    $self->{LC_m2_srcregion_XLength} = undef;
    $self->{LC_m2_srcregion_YLength} = undef;
    $self->{LC_m2_bkgregion_X}       = undef;
    $self->{LC_m2_bkgregion_Y}       = undef;
    $self->{LC_m2_bkgregion_R1}      = undef;
    $self->{LC_m2_bkgregion_R2}      = undef;
    $self->{LC_m2_bkgregion_XLength} = undef;
    $self->{LC_m2_bkgregion_YLength} = undef;
    $self->{LC_m2_areafactor}        = undef;
    $self->{LC_m2_rad_start_bkgregion} = undef;
    
    $self->{LC_pn_src_expr}    	  = undef;
    $self->{LC_pn_bkg_expr}          = undef;
    $self->{LC_m1_src_expr}          = undef;
    $self->{LC_m1_bkg_expr}          = undef;
    $self->{LC_m2_src_expr}          = undef;
    $self->{LC_m2_bkg_expr}          = undef;
    $self->{LC_pn_src_ds9region_file} = undef;
    $self->{LC_pn_bkg_ds9region_file} = undef;
    $self->{LC_m1_src_ds9region_file} = undef;
    $self->{LC_m1_bkg_ds9region_file} = undef;
    $self->{LC_m2_src_ds9region_file} = undef;
    $self->{LC_m2_bkg_ds9region_file} = undef;

    $self->{LC_pn_timebinsize}   = undef;   
    $self->{LC_m1_timebinsize}   = undef;   
    $self->{LC_m2_timebinsize}   = undef;
   
    
    
    $self->{SPC_pn_specgrp_mincts}  = undef;
    $self->{SPC_m1_specgrp_mincts}  = undef;
    $self->{SPC_m2_specgrp_mincts}  = undef;
    $self->{SPC_pn_ener_low}        = undef;
    $self->{SPC_pn_ener_up}         = undef;
    $self->{SPC_m1_ener_low}        = undef;
    $self->{SPC_m1_ener_up}         = undef;
    $self->{SPC_m2_ener_low}        = undef;
    $self->{SPC_m2_ener_up}         = undef;
    $self->{SPC_pn_srcregion}         = undef;
    $self->{SPC_pn_bkgregion}         = undef;
    $self->{SPC_pn_srcregion_X}       = undef;
    $self->{SPC_pn_srcregion_Y}       = undef;
    $self->{SPC_pn_srcregion_R1}      = undef;
    $self->{SPC_pn_srcregion_R2}      = undef;
    $self->{SPC_pn_srcregion_XLength} = undef;
    $self->{SPC_pn_srcregion_YLength} = undef;
    $self->{SPC_pn_bkgregion_X}       = undef;
    $self->{SPC_pn_bkgregion_Y}       = undef;
    $self->{SPC_pn_bkgregion_R1}      = undef;
    $self->{SPC_pn_bkgregion_R2}      = undef;
    $self->{SPC_pn_bkgregion_XLength} = undef;
    $self->{SPC_pn_bkgregion_YLength} = undef;
    $self->{SPC_pn_areafactor}        = undef;
    $self->{SPC_pn_rad_start_bkgregion} = undef;
    $self->{SPC_m1_srcregion}         = undef;
    $self->{SPC_m1_bkgregion}         = undef;
    $self->{SPC_m1_srcregion_X}       = undef;
    $self->{SPC_m1_srcregion_Y}       = undef;
    $self->{SPC_m1_srcregion_R1}      = undef;
    $self->{SPC_m1_srcregion_R2}      = undef;
    $self->{SPC_m1_srcregion_XLength} = undef;
    $self->{SPC_m1_srcregion_YLength} = undef;
    $self->{SPC_m1_bkgregion_X}       = undef;
    $self->{SPC_m1_bkgregion_Y}       = undef;
    $self->{SPC_m1_bkgregion_R1}      = undef;
    $self->{SPC_m1_bkgregion_R2}      = undef;
    $self->{SPC_m1_bkgregion_XLength} = undef;
    $self->{SPC_m1_bkgregion_YLength} = undef;
    $self->{SPC_m1_areafactor}        = undef;
    $self->{SPC_m1_rad_start_bkgregion} = undef;
    $self->{SPC_m2_srcregion}         = undef;
    $self->{SPC_m2_bkgregion}         = undef;
    $self->{SPC_m2_srcregion_X}       = undef;
    $self->{SPC_m2_srcregion_Y}       = undef;
    $self->{SPC_m2_srcregion_R1}      = undef;
    $self->{SPC_m2_srcregion_R2}      = undef;
    $self->{SPC_m2_srcregion_XLength} = undef;
    $self->{SPC_m2_srcregion_YLength} = undef;
    $self->{SPC_m2_bkgregion_X}       = undef;
    $self->{SPC_m2_bkgregion_Y}       = undef;
    $self->{SPC_m2_bkgregion_R1}      = undef;
    $self->{SPC_m2_bkgregion_R2}      = undef;
    $self->{SPC_m2_bkgregion_XLength} = undef;
    $self->{SPC_m2_bkgregion_YLength} = undef;
    $self->{SPC_m2_areafactor}        = undef;
    $self->{SPC_m2_rad_start_bkgregion} = undef;
    
    $self->{SPC_pn_src_expr}    	  = undef;
    $self->{SPC_pn_bkg_expr}          = undef;
    $self->{SPC_m1_src_expr}          = undef;
    $self->{SPC_m1_bkg_expr}          = undef;
    $self->{SPC_m2_src_expr}          = undef;
    $self->{SPC_m2_bkg_expr}          = undef;
    $self->{SPC_pn_src_ds9region_file} = undef;
    $self->{SPC_pn_bkg_ds9region_file} = undef;
    $self->{SPC_m1_src_ds9region_file} = undef;
    $self->{SPC_m1_bkg_ds9region_file} = undef;
    $self->{SPC_m2_src_ds9region_file} = undef;
    $self->{SPC_m2_bkg_ds9region_file} = undef;
    
    
    $self->{LC_rgs1_orders}         = "1 2";
    $self->{LC_rgs1_srcid}         = undef;
    $self->{LC_rgs1_timebinsize}         = 200;
    $self->{LC_rgs2_orders}         = "1 2";
    $self->{LC_rgs2_srcid}         = undef;
    $self->{LC_rgs2_timebinsize}         = 200;
    

    	   
    bless($self);          
    return $self;
}

##############################################
## methods to access per-object data        ##
##                                          ##
## With args, they set the value.  Without  ##
## any, they only retrieve it/them.         ## 
##############################################

sub SRC_Name {
    my $self = shift;
    if (@_) { $self->{SRC_Name}  = shift }
    return $self->{SRC_Name};
}
sub SRC_OBSID {
    my $self = shift;
    if (@_) { $self->{SRC_OBSID}  = shift }
    return $self->{SRC_OBSID};
}
sub SRC_EXP {
    my $self = shift;
    if (@_) { $self->{SRC_EXP}  = shift }
    return $self->{SRC_EXP};
}
sub SRC_RA {
    my $self = shift;
    if (@_) { $self->{SRC_RA}  = shift }
    return $self->{SRC_RA};
}
sub SRC_DEC {
    my $self = shift;
    if (@_) { $self->{SRC_DEC}  = shift }
    return $self->{SRC_DEC};
}
sub SRC_NH {
    my $self = shift;
    if (@_) { $self->{SRC_NH}  = shift }
    return $self->{SRC_NH};
}
sub EDC_sourcematch {
    my $self = shift;
    if (@_) { $self->{EDC_sourcematch}  = shift }
    return $self->{EDC_sourcematch};
}
sub EDC_cameramatch {
    my $self = shift;
    if (@_) { $self->{EDC_cameramatch}  = shift }
    return $self->{EDC_cameramatch};
}
sub EDC_pn_ene_low {
    my $self = shift;
    if (@_) { @{ $self->{EDC_pn_ene_low} } = @_ }
    return @{ $self->{EDC_pn_ene_low} };
}
sub EDC_pn_ene_high {
    my $self = shift;
    if (@_) { @{ $self->{EDC_pn_ene_high} } = @_ }
    return @{ $self->{EDC_pn_ene_high} };
}
sub EDC_m1_ene_low {
    my $self = shift;
    if (@_) { @{ $self->{EDC_m1_ene_low} } = @_ }
    return @{ $self->{EDC_m1_ene_low} };
}
sub EDC_m1_ene_high {
    my $self = shift;
    if (@_) { @{ $self->{EDC_m1_ene_high} } = @_ }
    return @{ $self->{EDC_m1_ene_high} };
}
sub EDC_m2_ene_low {
    my $self = shift;
    if (@_) { @{ $self->{EDC_m2_ene_low} } = @_ }
    return @{ $self->{EDC_m2_ene_low} };
}
sub EDC_m2_ene_high {
    my $self = shift;
    if (@_) { @{ $self->{EDC_m2_ene_high} } = @_ }
    return @{ $self->{EDC_m2_ene_high} };
}
sub EDC_pn_likelihood_detection {
    my $self = shift; 
    if (@_) { $self->{EDC_pn_likelihood_detection} = shift }
    return $self->{EDC_pn_likelihood_detection};
}
sub EDC_mos_likelihood_detection {
    my $self = shift; 
    if (@_) { $self->{EDC_mos_likelihood_detection} = shift }
    return $self->{EDC_mos_likelihood_detection};
}
sub OM_sourcematch {
    my $self = shift; 
    if (@_) { $self->{OM_sourcematch} = shift }
    return $self->{OM_sourcematch};
}
sub GTI_optimize_SN_flag {
    my $self = shift; 
    if (@_) { $self->{GTI_optimize_SN_flag} = shift }
    return $self->{GTI_optimize_SN_flag};
}
sub GTI_mos1energy_cut {
    my $self = shift; 
    if (@_) { $self->{GTI_mos1energy_cut} = shift }
    return $self->{GTI_mos1energy_cut};
}
sub GTI_mos2energy_cut {
    my $self = shift; 
    if (@_) { $self->{GTI_mos2energy_cut} = shift }
    return $self->{GTI_mos2energy_cut};
}
sub GTI_pnenergy_cut {
    my $self = shift; 
    if (@_) { $self->{GTI_pnenergy_cut} = shift }
    return $self->{GTI_pnenergy_cut};
}
sub GTI_MOS1_Rate {
    my $self = shift; 
    if (@_) { $self->{GTI_MOS1_Rate} = shift }
    return $self->{GTI_MOS1_Rate};
}
sub GTI_MOS2_Rate {
    my $self = shift; 
    if (@_) { $self->{GTI_MOS2_Rate} = shift }
    return $self->{GTI_MOS2_Rate};
}
sub GTI_PN_Rate {
    my $self = shift; 
    if (@_) { $self->{GTI_PN_Rate} = shift }
    return $self->{GTI_PN_Rate};
}
sub GTI_timebin {
    my $self = shift; 
    if (@_) { $self->{GTI_timebin} = shift }
    return $self->{GTI_timebin};
}
sub PG_timebinning{
    my $self = shift; 
    if (@_) { $self->{PG_timebinning} = shift }
    return $self->{PG_timebinning};
}
sub PG_timestart{
    my $self = shift; 
    if (@_) { $self->{PG_timestart} = shift }
    return $self->{PG_timestart};
}
sub PG_timeend{
    my $self = shift; 
    if (@_) { $self->{PG_timeend} = shift }
    return $self->{PG_timeend};
}
sub PG_minpi{
    my $self = shift; 
    if (@_) { $self->{PG_minpi} = shift }
    return $self->{PG_minpi};
}      
sub PG_maxpi{
    my $self = shift; 
    if (@_) { $self->{PG_maxpi} = shift }
    return $self->{PG_maxpi};
}      
sub PG_aringcx{
    my $self = shift; 
    if (@_) { $self->{PG_aringcx} = shift }
    return $self->{PG_aringcx};
}    
sub PG_aringcy{
    my $self = shift; 
    if (@_) { $self->{PG_aringcy} = shift }
    return $self->{PG_aringcy};
}    
sub PG_innerrad{
    my $self = shift; 
    if (@_) { $self->{PG_innerrad} = shift }
    return $self->{PG_innerrad};
}   
sub PG_outerrad{
    my $self = shift; 
    if (@_) { $self->{PG_outerrad} = shift }
    return $self->{PG_outerrad};
}   
sub PG_sx{
    my $self = shift; 
    if (@_) { $self->{PG_sx} = shift }
    return $self->{PG_sx};
}         
sub PG_sy{
    my $self = shift; 
    if (@_) { $self->{PG_sy} = shift }
    return $self->{PG_sy};
}         
sub PG_source_rad{
    my $self = shift; 
    if (@_) { $self->{PG_source_rad} = shift }
    return $self->{PG_source_rad};
}
sub PG_areafactor{
    my $self = shift; 
    if (@_) { $self->{PG_areafactor} = shift }
    return $self->{PG_areafactor};
}
sub LC_pn_timebin{
    my $self = shift; 
    if (@_) { $self->{LC_pn_timebin} = shift }
    return $self->{LC_pn_timebin};
}
sub LC_m1_timebin{
    my $self = shift; 
    if (@_) { $self->{LC_m1_timebin} = shift }
    return $self->{LC_m1_timebin};
}
sub LC_m2_timebin{
    my $self = shift; 
    if (@_) { $self->{LC_m2_timebin} = shift }
    return $self->{LC_m2_timebin};
}
sub LC_lc_pn_enertot_low{
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_enertot_low} = shift }
    return $self->{LC_lc_pn_enertot_low};
}
sub LC_lc_pn_enertot_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_enertot_up} = shift }
    return $self->{LC_lc_pn_enertot_up}; 
}
sub LC_lc_pn_ener1_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_ener1_low} = shift }
    return $self->{LC_lc_pn_ener1_low};  	      
}
sub LC_lc_pn_ener1_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_ener1_up} = shift }
    return $self->{LC_lc_pn_ener1_up};
}    
sub LC_lc_pn_ener2_low{
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_ener2_low} = shift }
    return $self->{LC_lc_pn_ener2_low};
}    
sub LC_lc_pn_ener2_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_ener2_up} = shift }
    return $self->{LC_lc_pn_ener2_up}; 
}   
sub LC_lc_pn_ener3_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_ener3_low} = shift }
    return $self->{LC_lc_pn_ener3_low};
}     
sub LC_lc_pn_ener3_up{
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_ener3_up} = shift }
    return $self->{LC_lc_pn_ener3_up};
}      
sub LC_lc_m1_enertot_low{
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_enertot_low} = shift }
    return $self->{LC_lc_m1_enertot_low};
} 
sub LC_lc_m1_enertot_up{
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_enertot_up} = shift }
    return $self->{LC_lc_m1_enertot_up}; 
}  
sub LC_lc_m1_ener1_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_ener1_low} = shift }
    return $self->{LC_lc_m1_ener1_low}; 
}   
sub LC_lc_m1_ener1_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_ener1_up} = shift }
    return $self->{LC_lc_m1_ener1_up}; 
}     
sub LC_lc_m1_ener2_low{
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_ener2_low} = shift }
    return $self->{LC_lc_m1_ener2_low}; 
}    
sub LC_lc_m1_ener2_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_ener2_up} = shift }
    return $self->{LC_lc_m1_ener2_up}; 
}  
sub LC_lc_m1_ener3_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_ener3_low} = shift }
    return $self->{LC_lc_m1_ener3_low};
}    
sub LC_lc_m1_ener3_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_ener3_up} = shift }
    return $self->{LC_lc_m1_ener3_up};
}    
sub LC_lc_m2_enertot_low{
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_enertot_low} = shift }
    return $self->{LC_lc_m2_enertot_low};
}   
sub LC_lc_m2_enertot_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_enertot_up} = shift }
    return $self->{LC_lc_m2_enertot_up}; 
} 
sub LC_lc_m2_ener1_low{
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_ener1_low} = shift }
    return $self->{LC_lc_m2_ener1_low}; 
}    
sub LC_lc_m2_ener1_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_ener1_up} = shift }
    return $self->{LC_lc_m2_ener1_up}; 
}   
sub LC_lc_m2_ener2_low{
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_ener2_low} = shift }
    return $self->{LC_lc_m2_ener2_low};
}    
sub LC_lc_m2_ener2_up{
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_ener2_up} = shift }
    return $self->{LC_lc_m2_ener2_up}; 
}     
sub LC_lc_m2_ener3_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_ener3_low} = shift }
    return $self->{LC_lc_m2_ener3_low};
}  	      
sub LC_lc_m2_ener3_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_ener3_up} = shift }
    return $self->{LC_lc_m2_ener3_up};
}  
sub LC_lc_pn_highrad_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_highrad_low} = shift }
    return $self->{LC_lc_pn_highrad_low};
}  
sub LC_lc_pn_highrad_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_highrad_up} = shift }
    return $self->{LC_lc_pn_highrad_up};
}  
sub LC_lc_m1_highrad_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_highrad_low} = shift }
    return $self->{LC_lc_m1_highrad_low};
}  
sub LC_lc_m1_highrad_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_highrad_up} = shift }
    return $self->{LC_lc_m1_highrad_up};
}  
sub LC_lc_m2_highrad_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_highrad_low} = shift }
    return $self->{LC_lc_m2_highrad_low};
}  
sub LC_lc_m2_highrad_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_highrad_up} = shift }
    return $self->{LC_lc_m2_highrad_up};
}  
sub LC_lc_pn_e1_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_e1_low} = shift }
    return $self->{LC_lc_pn_e1_low};
}  
sub LC_lc_pn_e1_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_e1_up} = shift }
    return $self->{LC_lc_pn_e1_up};
}  
sub LC_lc_pn_e2_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_e2_low} = shift }
    return $self->{LC_lc_pn_e2_low};
}  
sub LC_lc_pn_e2_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_pn_e2_up} = shift }
    return $self->{LC_lc_pn_e2_up};
}  
sub LC_lc_m1_e1_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_e1_low} = shift }
    return $self->{LC_lc_m1_e1_low};
}  
sub LC_lc_m1_e1_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_e1_up} = shift }
    return $self->{LC_lc_m1_e1_up};
}  
sub LC_lc_m1_e2_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_e2_low} = shift }
    return $self->{LC_lc_m1_e2_low};
}  
sub LC_lc_m1_e2_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m1_e2_up} = shift }
    return $self->{LC_lc_m1_e2_up};
}  
sub LC_lc_m2_e1_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_e1_low} = shift }
    return $self->{LC_lc_m2_e1_low};
}  
sub LC_lc_m2_e1_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_e1_up} = shift }
    return $self->{LC_lc_m2_e1_up};
}  
sub LC_lc_m2_e2_low{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_e2_low} = shift }
    return $self->{LC_lc_m2_e2_low};
}  
sub LC_lc_m2_e2_up{ 
    my $self = shift; 
    if (@_) { $self->{LC_lc_m2_e2_up} = shift }
    return $self->{LC_lc_m2_e2_up};
}  
sub LC_pn_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion} = shift }
    return $self->{LC_pn_srcregion};
}          
sub LC_pn_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion} = shift }
    return $self->{LC_pn_bkgregion};
}    
sub LC_pn_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_X} = shift }
    return $self->{LC_pn_srcregion_X};
}    
sub LC_pn_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_Y} = shift }
    return $self->{LC_pn_srcregion_Y};
}    
sub LC_pn_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_R1} = shift }
    return $self->{LC_pn_srcregion_R1};
}    
sub LC_pn_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_R2} = shift }
    return $self->{LC_pn_srcregion_R2};
}    
sub LC_pn_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_XLength} = shift }
    return $self->{LC_pn_srcregion_XLength};
}    
sub LC_pn_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_srcregion_YLength} = shift }
    return $self->{LC_pn_srcregion_YLength};
}    
sub LC_pn_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_X} = shift }
    return $self->{LC_pn_bkgregion_X};
}    
sub LC_pn_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_Y} = shift }
    return $self->{LC_pn_bkgregion_Y};
}      
sub LC_pn_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_R1} = shift }
    return $self->{LC_pn_bkgregion_R1};
}    
sub LC_pn_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_R2} = shift }
    return $self->{LC_pn_bkgregion_R2};
}    
sub LC_pn_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_XLength} = shift }
    return $self->{LC_pn_bkgregion_XLength};
}    
sub LC_pn_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkgregion_YLength} = shift }
    return $self->{LC_pn_bkgregion_YLength};
}    
sub LC_pn_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn__areafactor} = shift }
    return $self->{LC_pn__areafactor};
}        
sub LC_pn_rad_start_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_rad_start_bkgregion} = shift }
    return $self->{LC_pn_rad_start_bkgregion};
}  
sub LC_m1_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion} = shift }
    return $self->{LC_m1_srcregion};
}          
sub LC_m1_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion} = shift }
    return $self->{LC_m1_bkgregion};
}    
sub LC_m1_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_X} = shift }
    return $self->{LC_m1_srcregion_X};
}    
sub LC_m1_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_Y} = shift }
    return $self->{LC_m1_srcregion_Y};
}    
sub LC_m1_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_R1} = shift }
    return $self->{LC_m1_srcregion_R1};
}    
sub LC_m1_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_R2} = shift }
    return $self->{LC_m1_srcregion_R2};
}    
sub LC_m1_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_XLength} = shift }
    return $self->{LC_m1_srcregion_XLength};
}    
sub LC_m1_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_srcregion_YLength} = shift }
    return $self->{LC_m1_srcregion_YLength};
}    
sub LC_m1_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_X} = shift }
    return $self->{LC_m1_bkgregion_X};
}    
sub LC_m1_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_Y} = shift }
    return $self->{LC_m1_bkgregion_Y};
}    
sub LC_m1_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_R1} = shift }
    return $self->{LC_m1_bkgregion_R1};
}    
sub LC_m1_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_R2} = shift }
    return $self->{LC_m1_bkgregion_R2};
}    
sub LC_m1_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_XLength} = shift }
    return $self->{LC_m1_bkgregion_XLength};
}    
sub LC_m1_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkgregion_YLength} = shift }
    return $self->{LC_m1_bkgregion_YLength};
}    
sub LC_m1_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_areafactor} = shift }
    return $self->{LC_m1_areafactor};
}        
sub LC_m1_rad_start_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_rad_start_bkgregion} = shift }
    return $self->{LC_m1_rad_start_bkgregion};
} 
sub LC_m2_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion} = shift }
    return $self->{LC_m2_srcregion};
}          
sub LC_m2_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion} = shift }
    return $self->{LC_m2_bkgregion};
}    
sub LC_m2_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_X} = shift }
    return $self->{LC_m2_srcregion_X};
}    
sub LC_m2_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_Y} = shift }
    return $self->{LC_m2_srcregion_Y};
}    
sub LC_m2_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_R1} = shift }
    return $self->{LC_m2_srcregion_R1};
}    
sub LC_m2_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_R2} = shift }
    return $self->{LC_m2_srcregion_R2};
}    
sub LC_m2_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_XLength} = shift }
    return $self->{LC_m2_srcregion_XLength};
}    
sub LC_m2_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_srcregion_YLength} = shift }
    return $self->{LC_m2_srcregion_YLength};
}    
sub LC_m2_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_X} = shift }
    return $self->{LC_m2_bkgregion_X};
}    
sub LC_m2_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_Y} = shift }
    return $self->{LC_m2_bkgregion_Y};
}    
sub LC_m2_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_R1} = shift }
    return $self->{LC_m2_bkgregion_R1};
}    
sub LC_m2_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_R2} = shift }
    return $self->{LC_m2_bkgregion_R2};
}    
sub LC_m2_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_XLength} = shift }
    return $self->{LC_m2_bkgregion_XLength};
}    
sub LC_m2_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkgregion_YLength} = shift }
    return $self->{LC_m2_bkgregion_YLength};
}    
sub LC_m2_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_areafactor} = shift }
    return $self->{LC_m2_areafactor};
}        
sub LC_m2_rad_start_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_rad_start_bkgregion} = shift }
    return $self->{LC_m2_rad_start_bkgregion};
} 
sub SPC_pn_specgrp_mincts{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_specgrp_mincts} = shift }
    return $self->{SPC_pn_specgrp_mincts};
}  
sub SPC_m1_specgrp_mincts{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_specgrp_mincts} = shift }
    return $self->{SPC_m1_specgrp_mincts};
}  
sub SPC_m2_specgrp_mincts{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_specgrp_mincts} = shift }
    return $self->{SPC_m2_specgrp_mincts};
}  
sub SPC_pn_ener_low{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_ener_low} = shift }
    return $self->{SPC_pn_ener_low};
}  
sub SPC_pn_ener_up{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_ener_up} = shift }
    return $self->{SPC_pn_ener_up};
}  
sub SPC_m1_ener_low{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_ener_low} = shift }
    return $self->{SPC_m1_ener_low};
}  
sub SPC_m1_ener_up{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_ener_up} = shift }
    return $self->{SPC_m1_ener_up};
}  
sub SPC_m2_ener_low{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_ener_low} = shift }
    return $self->{SPC_m2_ener_low};
}  
sub SPC_m2_ener_up{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_ener_up} = shift }
    return $self->{SPC_m2_ener_up};
}  
sub SPC_pn_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion} = shift }
    return $self->{SPC_pn_srcregion};
}          
sub SPC_pn_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion} = shift }
    return $self->{SPC_pn_bkgregion};
}    
sub SPC_pn_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_X} = shift }
    return $self->{SPC_pn_srcregion_X};
}    
sub SPC_pn_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_Y} = shift }
    return $self->{SPC_pn_srcregion_Y};
}    
sub SPC_pn_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_R1} = shift }
    return $self->{SPC_pn_srcregion_R1};
}    
sub SPC_pn_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_R2} = shift }
    return $self->{SPC_pn_srcregion_R2};
}    
sub SPC_pn_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_XLength} = shift }
    return $self->{SPC_pn_srcregion_XLength};
}    
sub SPC_pn_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_srcregion_YLength} = shift }
    return $self->{SPC_pn_srcregion_YLength};
}    
sub SPC_pn_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_X} = shift }
    return $self->{SPC_pn_bkgregion_X};
}    
sub SPC_pn_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_Y} = shift }
    return $self->{SPC_pn_bkgregion_Y};
}      
sub SPC_pn_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_R1} = shift }
    return $self->{SPC_pn_bkgregion_R1};
}    
sub SPC_pn_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_R2} = shift }
    return $self->{SPC_pn_bkgregion_R2};
}    
sub SPC_pn_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_XLength} = shift }
    return $self->{SPC_pn_bkgregion_XLength};
}    
sub SPC_pn_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkgregion_YLength} = shift }
    return $self->{SPC_pn_bkgregion_YLength};
}    
sub SPC_pn_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn__areafactor} = shift }
    return $self->{SPC_pn__areafactor};
}        
sub SPC_pn_rad_start_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_rad_start_bkgregion} = shift }
    return $self->{SPC_pn_rad_start_bkgregion};
}  
sub SPC_m1_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion} = shift }
    return $self->{SPC_m1_srcregion};
}          
sub SPC_m1_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion} = shift }
    return $self->{SPC_m1_bkgregion};
}    
sub SPC_m1_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_X} = shift }
    return $self->{SPC_m1_srcregion_X};
}    
sub SPC_m1_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_Y} = shift }
    return $self->{SPC_m1_srcregion_Y};
}    
sub SPC_m1_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_R1} = shift }
    return $self->{SPC_m1_srcregion_R1};
}    
sub SPC_m1_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_R2} = shift }
    return $self->{SPC_m1_srcregion_R2};
}    
sub SPC_m1_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_XLength} = shift }
    return $self->{SPC_m1_srcregion_XLength};
}    
sub SPC_m1_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_srcregion_YLength} = shift }
    return $self->{SPC_m1_srcregion_YLength};
}    
sub SPC_m1_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_X} = shift }
    return $self->{SPC_m1_bkgregion_X};
}    
sub SPC_m1_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_Y} = shift }
    return $self->{SPC_m1_bkgregion_Y};
}    
sub SPC_m1_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_R1} = shift }
    return $self->{SPC_m1_bkgregion_R1};
}    
sub SPC_m1_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_R2} = shift }
    return $self->{SPC_m1_bkgregion_R2};
}    
sub SPC_m1_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_XLength} = shift }
    return $self->{SPC_m1_bkgregion_XLength};
}    
sub SPC_m1_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkgregion_YLength} = shift }
    return $self->{SPC_m1_bkgregion_YLength};
}    
sub SPC_m1_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_areafactor} = shift }
    return $self->{SPC_m1_areafactor};
}        
sub SPC_m1_rad_start_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_rad_start_bkgregion} = shift }
    return $self->{SPC_m1_rad_start_bkgregion};
} 
sub SPC_m2_srcregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion} = shift }
    return $self->{SPC_m2_srcregion};
}          
sub SPC_m2_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion} = shift }
    return $self->{SPC_m2_bkgregion};
}    
sub SPC_m2_srcregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_X} = shift }
    return $self->{SPC_m2_srcregion_X};
}    
sub SPC_m2_srcregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_Y} = shift }
    return $self->{SPC_m2_srcregion_Y};
}    
sub SPC_m2_srcregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_R1} = shift }
    return $self->{SPC_m2_srcregion_R1};
}    
sub SPC_m2_srcregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_R2} = shift }
    return $self->{SPC_m2_srcregion_R2};
}    
sub SPC_m2_srcregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_XLength} = shift }
    return $self->{SPC_m2_srcregion_XLength};
}    
sub SPC_m2_srcregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_srcregion_YLength} = shift }
    return $self->{SPC_m2_srcregion_YLength};
}    
sub SPC_m2_bkgregion_X{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_X} = shift }
    return $self->{SPC_m2_bkgregion_X};
}    
sub SPC_m2_bkgregion_Y{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_Y} = shift }
    return $self->{SPC_m2_bkgregion_Y};
}    
sub SPC_m2_bkgregion_R1{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_R1} = shift }
    return $self->{SPC_m2_bkgregion_R1};
}    
sub SPC_m2_bkgregion_R2{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_R2} = shift }
    return $self->{SPC_m2_bkgregion_R2};
}    
sub SPC_m2_bkgregion_XLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_XLength} = shift }
    return $self->{SPC_m2_bkgregion_XLength};
}    
sub SPC_m2_bkgregion_YLength{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkgregion_YLength} = shift }
    return $self->{SPC_m2_bkgregion_YLength};
}    
sub SPC_m2_areafactor{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_areafactor} = shift }
    return $self->{SPC_m2_areafactor};
}        
sub SPC_m2_rad_start_bkgregion{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_rad_start_bkgregion} = shift }
    return $self->{SPC_m2_rad_start_bkgregion};
} 

sub LC_rgs1_orders{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs1_orders} = shift }
    return $self->{LC_rgs1_orders};
} 

sub LC_rgs1_srcid{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs1_srcid} = shift }
    return $self->{LC_rgs1_srcid};
} 

sub LC_rgs1_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs1_timebinsize} = shift }
    return $self->{LC_rgs1_timebinsize};
}

sub LC_rgs2_orders{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs2_orders} = shift }
    return $self->{LC_rgs2_orders};
} 

sub LC_rgs2_srcid{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs2_srcid} = shift }
    return $self->{LC_rgs2_srcid};
} 

sub LC_rgs2_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_rgs2_timebinsize} = shift }
    return $self->{LC_rgs2_timebinsize};
}

sub PN{ 
    my $self = shift; 
    if (@_) { $self->{PN} = shift }
    return $self->{PN};
}

sub MOS{ 
    my $self = shift; 
    if (@_) { $self->{MOS} = shift }
    return $self->{MOS};
}

sub RGS{ 
    my $self = shift; 
    if (@_) { $self->{RGS} = shift }
    return $self->{RGS};
}

sub OM{ 
    my $self = shift; 
    if (@_) { $self->{OM} = shift }
    return $self->{OM};
}

sub ANA_epatplot{ 
    my $self = shift; 
    if (@_) { $self->{ANA_epatplot} = shift }
    return $self->{ANA_epatplot};
}
 
sub SPC_pn_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_src_expr} = shift }
    return $self->{SPC_pn_src_expr};
}

sub SPC_pn_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkg_expr} = shift }
    return $self->{SPC_pn_bkg_expr};
}

sub SPC_m1_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_src_expr} = shift }
    return $self->{SPC_m1_src_expr};
}
sub SPC_m1_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkg_expr} = shift }
    return $self->{SPC_m1_bkg_expr};
}
sub SPC_m2_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_src_expr} = shift }
    return $self->{SPC_m2_src_expr};
}
sub SPC_m2_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkg_expr} = shift }
    return $self->{SPC_m2_bkg_expr};
}

sub SPC_pn_src_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_src_ds9region_file} = shift }
    return $self->{SPC_pn_src_ds9region_file};
}

sub SPC_pn_bkg_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_pn_bkg_ds9region_file} = shift }
    return $self->{SPC_pn_bkg_ds9region_file};
}

sub SPC_m1_src_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_src_ds9region_file} = shift }
    return $self->{SPC_m1_src_ds9region_file};
}
sub SPC_m1_bkg_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m1_bkg_ds9region_file} = shift }
    return $self->{SPC_m1_bkg_ds9region_file};
}
sub SPC_m2_src_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_src_ds9region_file} = shift }
    return $self->{SPC_m2_src_ds9region_file};
}
sub SPC_m2_bkg_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{SPC_m2_bkg_ds9region_file} = shift }
    return $self->{SPC_m2_bkg_ds9region_file};
}
 
sub LC_pn_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_src_expr} = shift }
    return $self->{LC_pn_src_expr};
}

sub LC_pn_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkg_expr} = shift }
    return $self->{LC_pn_bkg_expr};
}

sub LC_m1_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_src_expr} = shift }
    return $self->{LC_m1_src_expr};
}
sub LC_m1_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkg_expr} = shift }
    return $self->{LC_m1_bkg_expr};
}
sub LC_m2_src_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_src_expr} = shift }
    return $self->{LC_m2_src_expr};
}
sub LC_m2_bkg_expr{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkg_expr} = shift }
    return $self->{LC_m2_bkg_expr};
}

sub LC_pn_src_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_src_ds9region_file} = shift }
    return $self->{LC_pn_src_ds9region_file};
}

sub LC_pn_bkg_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_bkg_ds9region_file} = shift }
    return $self->{LC_pn_bkg_ds9region_file};
}

sub LC_m1_src_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_src_ds9region_file} = shift }
    return $self->{LC_m1_src_ds9region_file};
}
sub LC_m1_bkg_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_bkg_ds9region_file} = shift }
    return $self->{LC_m1_bkg_ds9region_file};
}
sub LC_m2_src_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_src_ds9region_file} = shift }
    return $self->{LC_m2_src_ds9region_file};
}
sub LC_m2_bkg_ds9region_file{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_bkg_ds9region_file} = shift }
    return $self->{LC_m2_bkg_ds9region_file};
}
 
 
 
 sub LC_pn_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_pn_timebinsize} = shift }
    return $self->{LC_pn_timebinsize};
}

sub LC_m1_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_m1_timebinsize} = shift }
    return $self->{LC_m1_timebinsize};
}

sub LC_m2_timebinsize{ 
    my $self = shift; 
    if (@_) { $self->{LC_m2_timebinsize} = shift }
    return $self->{LC_m2_timebinsize};
}

1;
